#	include	"ecoff.h"

// This is a completly new loader.  There wasn't anything technically
// wrong with the old one.  Just I wanted to remove some of
// the confusion surrounding the loader.  This new one is
// hopefully pretty easy to understand.


typedef	struct	_ExecFile
	{
	struct	ecoff_filehdr	FileHeader;
	struct	ecoff_aouthdr	aoutHeader;
	struct	ecoff_scnhdr	textHeader;
	struct	ecoff_scnhdr	rdataHeader;
	struct	ecoff_scnhdr	dataHeader;
	struct	ecoff_scnhdr	sdataHeader;
	struct	ecoff_scnhdr	sbssHeader;
	struct	ecoff_scnhdr	bssHeader;
	}	ExecFile;


class	Loader
	{
	public:
		static	bool	DumpHeader(struct	ecoff_filehdr	*fh);
		static	bool	DumpHeader(struct	ecoff_aouthdr	*ah);
		static	bool	DumpHeader(struct	ecoff_scnhdr	*sh);
		static	bool	DumpHeader(ExecFile	*ef);
		static	bool	LoadSegmentIntoMemorySystem(int	fd,
					ExecFile				*ef,
					struct	ecoff_scnhdr	*Section,
					MemorySystem			*ms);
		static	int			FormulateInitialStack (
				unsigned	int		StackBase,
				int					argc,
				char				*argv[],
				char				*argp[],
				unsigned			char	*Output);
		static	bool	LoadFromDevice(int	fd,
			MemorySystem		*ms,
			Processor			*p,
			char		**argv = NULL,
			char		**argp = NULL);
		static	bool	LoadFromDevice(char	*Filename,
			MemorySystem		*ms,
			Processor			*p,
			char		**argv = NULL,
			char		**argp = NULL);
	};


