
// The System trap handler (unlike other components)
// does not take a clock.  It is a completly fake I/O device
// that provides an interface to the underlying operating system
// Furthermore, it is not a real "component" for now.  Maybe
// that will change.

class	SystemTrapHandler	:
	public	Component
	{
	public:
		virtual	bool	HandleSystemTrap(
					Processor		*FromProcessor,
					SimInstruction	*AtInstruction);
	protected:
		virtual	bool	Perform_SS_SYS_exit(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_fork(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_vfork(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_read(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_open(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_write(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_close(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_creat(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_unlink(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_chdir(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_chmod(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_chown(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_brk(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_lseek(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_getuid(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_access(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_stat(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_lstat(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_dup(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_pipe(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_getgid(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_ioctl(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_fstat(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_getpagesize(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_fsync(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_dup2(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_fcntl(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_select(Processor *, SimRegister *);
		virtual	bool	Perform_SS_SYS_gettimeofday(Processor *, SimRegister *);
		virtual	bool	Perform_Unimplemented(Processor *, SimRegister *);
	};

